'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _buble = require('buble');

var _buble2 = _interopRequireDefault(_buble);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _stream = require('stream');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Bubleify = function (_Transform) {
  _inherits(Bubleify, _Transform);

  function Bubleify(filename, options) {
    _classCallCheck(this, Bubleify);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Bubleify).call(this));

    _this._data = '';
    _this._filename = filename;
    _this._options = (0, _objectAssign2.default)({ _flags: {} }, options);
    return _this;
  }

  _createClass(Bubleify, [{
    key: '_transform',
    value: function _transform(buf, enc, cb) {
      this._data += buf;
      cb();
    }
  }, {
    key: '_flush',
    value: function _flush(cb) {
      try {
        var result = _buble2.default.transform(this._data, this._bubleOptions);
        var code = result.code;

        // append sourcemaps to code

        if (this._options._flags.debug) {
          code += '\n//# sourceMappingURL=' + result.map.toUrl();
        }

        this.emit('bubleify', result, this._filename);
        this.push(code);
      } catch (err) {
        this.emit('error', err);
        return;
      }
      cb();
    }
  }, {
    key: '_bubleOptions',
    get: function get() {
      var defaults = { source: this._filename };
      var options = (0, _objectAssign2.default)(defaults, this._options);

      // copy properties to not modify the existing objects
      // set default transforms with deactivated modules
      options.transforms = (0, _objectAssign2.default)({ modules: false }, this._options.transforms);
      options.target = (0, _objectAssign2.default)({}, this._options.target);

      // remove browserify options
      delete options._flags;

      return options;
    }
  }]);

  return Bubleify;
}(_stream.Transform);

exports.default = function (filename, options) {
  return new Bubleify(filename, options);
};